/**
 * Copyright (c) 2009 Jeremy Stribling, Yair Sovran, Irene Zhang, 
 *                    Xavid Pretzer, Jinyang Li, Frans Kaashoek, Robert Morris,
 *     		      Massachusetts Institute of Technology,
 * 		      New York University
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


#ifndef __CHASH_H__
#define __CHASH_H__ 1

#include "wfs_file.h"
#include "wfs_node.h"

// generate a random ID between two node IDs, such that the end_id is
// a likely to be the successor of the ID and the start_id should be
// the predecessor (if no other node_ids exist in the range).
wfs_node_id rand_node_id_between( wfs_node_id start_id, wfs_node_id end_id );
wfs_file_id rand_file_id_between( wfs_node_id start_id, wfs_node_id end_id );


wfs_node_id sum_of_node_ids( wfs_node_id a, wfs_node_id b );
wfs_node_id diff_between_node_ids( wfs_node_id start_id, wfs_node_id end_id );
wfs_node_id rand_node_id();

bool between_ids_incl( wfs_node_id start, wfs_node_id end, wfs_node_id id );

#endif // __CHASH_H__
